/**
 * copyright 2006
 * Oct 10, 2006
 * 
 */
package org.ajaxdo.db;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.HashMap;

import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.sql.DataSource;

/**
 * @author Amir Shevat
 *
 */
public class AjaxdoDAO {
	
	private static AjaxdoDAO instance;
	private DataSource ds;
	
	private AjaxdoDAO(DataSource ds){
		this.ds = ds;
	}
	
	public  static  AjaxdoDAO getInstance(){
		/// i use a fast double lock becuse i do not realy care it i have 2 inatanses
		if(instance == null){
			synchronized(AjaxdoDAO.class){
				if(instance == null){
					Context ctx;
					try {
						ctx = new InitialContext();
						DataSource ds = (DataSource)ctx.lookup(
				               "java:comp/env/jdbc/AjaxdoDB1");
						System.out.println(ds);
						instance = new AjaxdoDAO(ds); 
					} catch (NamingException e) {
						e.printStackTrace();
						throw new RuntimeException(e);
						
					}
					
				}
			}
		}
		return instance; 
	}
	
	public String loadJavaScriptObject(String context, String objectID) throws SQLException{
		String result = null;
		Connection conn = ds.getConnection();
		Statement stmt = conn.createStatement();
		ResultSet rst = 
            stmt.executeQuery(
              "SELECT OBJECT_DATA FROM "+context+" WHERE OBJECT_NAME='"+objectID+"'");
        if(rst.next()) {
        	result=rst.getString(1);
           
        }
        conn.close();

		return result;
		
	}
	
	public int  deleteJavaScriptObject(String context, String objectID) throws SQLException{
		Connection conn = ds.getConnection();
		PreparedStatement pstmt =null;
		
		pstmt= conn.prepareStatement("DELETE FROM "+context+" WHERE OBJECT_NAME=?");
		
		pstmt.setString(1, objectID);
			
		int rows = pstmt.executeUpdate();
		conn.close();
		
		return rows;	
		
	}
	
	public int saveJavaScriptObject(String context, String objectID, String objectContent) throws SQLException{
		
		Connection conn = ds.getConnection();
		PreparedStatement pstmt =null;
		if (loadJavaScriptObject(context, objectID)==null){
			
			String p ="INSERT INTO "+context+" VALUES(?, ?, 1)" ;
			pstmt= conn.prepareStatement(p);
		
			pstmt.setString(1, objectID);
			pstmt.setString(2, objectContent);
			
			
		}else{
			pstmt= conn.prepareStatement("UPDATE "+context+" SET OBJECT_DATA=? WHERE OBJECT_NAME=?");
			
			pstmt.setString(1, objectContent);
			pstmt.setString(2, objectID);
		}
		int rows=0;
		try{
			rows= pstmt.executeUpdate();
		}catch(Throwable t ){
			t.printStackTrace();
		}
		
		conn.close();
		
		return rows;	
	}
	
	public HashMap listJavaScriptObject(String context) throws SQLException{
		HashMap result = new HashMap();
		Connection conn = ds.getConnection();
		Statement stmt = conn.createStatement();
		ResultSet rst = 
            stmt.executeQuery(
            		"SELECT OBJECT_NAME, OBJECT_TYPE  FROM "+context);
        while(rst.next()) {
        	String objectName=rst.getString("OBJECT_NAME");
        	String objectType=rst.getString("OBJECT_TYPE");
        	result.put(objectName, objectType);
        }
        conn.close();

		return result;
	
	}
	

}
